<?php

namespace Lc\CaracoleBundle\Repository;

use Lc\CaracoleBundle\Model\Merchant\MerchantInterface;
use Lc\CaracoleBundle\Model\Section\SectionInterface;

trait MerchantRepositoryQueryTrait
{
    protected MerchantInterface $merchant;

    public function setMerchant(MerchantInterface $merchant)
    {
        $this->merchant = $merchant;

        return $this;
    }

    public function filterByMerchant(MerchantInterface $merchant = null)
    {
        $this->andWhere('.merchant = :merchant');

        if(is_null($merchant)) {
            if(is_null($this->merchant)){
                throw new \ErrorException('Aucun merchant défini');
            }
            return $this->setParameter(':merchant', $this->merchant);
        }else{
            return $this->setParameter(':merchant', $merchant);

        }
    }
}
